import argparse


def arguments():
    parser = argparse.ArgumentParser()

    # Network architecture related
    parser.add_argument('--hid_dim', type=int, default=64,
                        help='Hidden dimension of GRU.')
    parser.add_argument('--msg_dim', type=int, default=8,
                        help='Dimension of query vector.')
    parser.add_argument('--inv_temp', type=float, default=1.0,
                        help='Inverse temperature value for Gumbel-Softmax (default: 1.0)')

    # Policy gradient related
    parser.add_argument('--gamma', type=float, default=0.8,
                        help='Discount factor.')
    parser.add_argument('--num_episodes', type=int, default=1001,
                        help='Number of episodes.')
    parser.add_argument('--episode_length', type=int, default=200,
                        help='Length of a single trajectory.')
    parser.add_argument('--learning_rate', type=float, default=1e-4,
                        help='Learning rate')
    parser.add_argument('--period', type=int, default=5,
                        help='Traffic signal alteration period.')

    # Other parameters
    parser.add_argument('--net_file', type=str, default='./maps/manhattan_1.net.xml',
                        help='Net file for SUMO.')
    parser.add_argument('--route_file', type=str, default='./maps/manhattan_1.rou.xml',
                        help='Route file for SUMO.')
    parser.add_argument('--shared_policy', type=bool, default=False, help='Whether to share policy or not')
    parser.add_argument('--blind_agents', type=str, default='', help='Comma separated IDs of blind agents')

    return parser.parse_args()
